package lightcontainer.domains;

import lightcontainer.interfaces.MulticastSPR;

import java.time.LocalDateTime;
import java.time.temporal.ChronoUnit;
import java.util.TimerTask;

/**
 * Class s'occupant de gérer les timeout des différents SBE
 */
public class FFETimer extends TimerTask {

    private final MulticastSPR processorRepository;

    public FFETimer(MulticastSPR processorRepository) {
        this.processorRepository = processorRepository;
    }

    @Override
    public void run() {
        for (String domain : processorRepository.getDomains()) {
            LocalDateTime lastAnnounce = processorRepository.getLastAnnounce(domain);
            long secondBetween = Math.abs(ChronoUnit.SECONDS.between(lastAnnounce, LocalDateTime.now()));

            if (secondBetween > 50) {
                processorRepository.closeStore(domain);
            }
        }
    }
}
