package lightcontainer.interfaces;

import lightcontainer.domains.client.ClientHandler;
import lightcontainer.domains.client.Context;
import lightcontainer.protocol.ProtocolWriter;
import lightcontainer.repository.FileFrontEnd;

/**
 * A communication interface between a {@link ClientHandler} and the {@link FileFrontEnd}.
 */
public interface ClientHandlerFFE {
    // functions

    /**
     * Demande le traitement d'une commande
     *
     * @param context Context de la requête
     * @param command Commande à traiter
     */
    void newCommand(Context context, ProtocolWriter.ProtocolResult command, String requestDomain);

    boolean canExecuteCommand(String domain);
}
