package lightcontainer.interfaces;

import lightcontainer.domains.client.StoreProcessor;
import lightcontainer.protocol.ProtocolWriter;
import lightcontainer.repository.FileFrontEnd;

/**
 * A communication interface between a {@link StoreProcessor} and the {@link FileFrontEnd}.
 */
public interface StoreProcessorFFE {
    /**
     * Allows a {@link StoreProcessor} to notify the FFE that it's available.
     *
     * @param storeDomain The store processor that is now available.
     * @param response
     */
    void onStoreAvailable(String storeDomain, ProtocolWriter.ProtocolResult response);

    /**
     * Permet de déconnecter un SBE
     *
     * @param domain Le domaine du SBE à déconnecter
     */
    void onStoreDisconnect(String domain);
}
