package lightcontainer.interfaces;

import lightcontainer.domains.client.ClientHandler;
import lightcontainer.domains.server.UnicastServerListener;
import lightcontainer.protocol.ProtocolWriter;
import lightcontainer.repository.ClientHandlerRepository;
import lightcontainer.repository.ReadOnlyClientRepository;

/**
 * A communication interface between a {@link ClientHandler} and the {@link ClientHandlerRepository}.
 */
public interface UnicastCHR extends ReadOnlyClientRepository {
    /**
     * Setter, allow to define the ServerListener of a repository.
     *
     * @param server ServerListener to set as default.
     */
    void setServerListener(UnicastServerListener server);

    /**
     * Add a ClientHandler.
     *
     * @param client Client Handler to add.
     */
    void addClient(ClientHandler client);


    /**
     * Permet de demander la déconnection d'un client
     *
     * @param client Le client à déconnecter
     */
    void disconnect(ClientHandler client);

    void respondToClient(String client, ProtocolWriter.ProtocolResult response);
}
