package lightcontainer.protocol.rules.reader;

import lightcontainer.domains.client.Context;
import lightcontainer.interfaces.ProtocolRepository;
import lightcontainer.protocol.ProtocolReader;
import lightcontainer.protocol.rules.writer.RemoveFileErrorRule;

import static lightcontainer.protocol.StandardizedDefinitions.SBE_ERASE_RESULT_ERROR;

public class EraseErrorRule extends ProtocolReader {
    //"^ERASE_ERROR\r\n$"
    private static final String PATTERN = SBE_ERASE_RESULT_ERROR;

    private static final String NAME = "ERASE_ERROR";

    private final ProtocolRepository protocolRep;


    public EraseErrorRule(ProtocolRepository protocolRep) {
        super(NAME, PATTERN);
        this.protocolRep = protocolRep;
    }

    @Override
    protected ProtocolResult onExecuted(Context context, String... data) {
        ProtocolReader.ProtocolResult result = new ProtocolReader.ProtocolResult(context);
        result.setResultCommand(protocolRep.executeWriter(context, RemoveFileErrorRule.NAME), ResultCmdReceiver.CLIENT);
        return result;
    }
}
