package lightcontainer.protocol.rules.reader;

import lightcontainer.domains.client.Context;
import lightcontainer.interfaces.ProtocolRepository;
import lightcontainer.protocol.ProtocolReader;
import lightcontainer.protocol.rules.writer.RemoveFileOkRule;

import static lightcontainer.protocol.StandardizedDefinitions.SBE_ERASE_RESULT_OK;

public class EraseOkRule extends ProtocolReader {

    private static final String PATTERN = SBE_ERASE_RESULT_OK;

    private static final String NAME = "ERASE_OK";

    private final ProtocolRepository protocolRep;

    public EraseOkRule(ProtocolRepository protocolRep) {
        super(NAME, PATTERN);
        this.protocolRep = protocolRep;
    }

    @Override
    protected ProtocolReader.ProtocolResult onExecuted(Context context, String... data) {
        ProtocolReader.ProtocolResult result = new ProtocolReader.ProtocolResult(context);
        String deletedFileName = context.getDataString("fileName");
        context.deleteFile(deletedFileName);
        result.setResultCommand(protocolRep.executeWriter(context, RemoveFileOkRule.NAME), ResultCmdReceiver.CLIENT);
        return result;
    }


}
