package lightcontainer.protocol.rules.reader;

import lightcontainer.domains.client.Context;
import lightcontainer.interfaces.ProtocolRepository;
import lightcontainer.protocol.ProtocolReader;
import lightcontainer.protocol.rules.writer.SaveFileOkRule;

import static lightcontainer.protocol.StandardizedDefinitions.SBE_SEND_RESULT_OK;

/**
 * Règle permettant de de confirmer la sauvegrade d'un fichier.
 */
public class SendOkRule extends ProtocolReader {

    // Constants
    //"^SEND_OK\r\n$"
    private static final String PATTERN = SBE_SEND_RESULT_OK;

    private static final String NAME = "SEND_OK";

    private final ProtocolRepository protocolRep;

    // Constructor
    public SendOkRule(ProtocolRepository protocolRep) {
        super(NAME, PATTERN);
        this.protocolRep = protocolRep;
    }

    @Override
    protected ProtocolResult onExecuted(Context context, String... data) {
        ProtocolReader.ProtocolResult result = new ProtocolReader.ProtocolResult(context);
        result.setResultCommand(protocolRep.executeWriter(context, SaveFileOkRule.NAME), ResultCmdReceiver.CLIENT);
        return result;
    }
}
