package lightcontainer.utils;

import java.io.*;

public class FileReceiver {
    private final String path;

    public FileReceiver(String path) {
        this.path = path;
    }

    public int receiveFile(InputStream input, String fileName, long fileSize, String key, String iv) {
        try {
            File file = new File(String.format("%s/%s", path, fileName));
            if (file.createNewFile()) {
                try (BufferedOutputStream bufferedStream = new BufferedOutputStream(new FileOutputStream(file))) {
                    // AES close l'outputstream mais on le try with ressources au cas ou ;)
                    AES_GCM.encryptStream(input, bufferedStream, fileSize, key, iv);
                }
            }
            return (int) file.length(); // TODO change the size to LONG
        } catch (IOException | AES_GCM.AesGcmException ex) {
            ex.printStackTrace();
            return -1;
        }
    }

    public boolean receiveFile(InputStream input, String fileName, long fileSize) {
        int bytesReceived = 0;
        BufferedOutputStream bosFile = null;

        try {
            byte[] buffer = new byte[1024];
            bosFile = new BufferedOutputStream(new FileOutputStream(String.format("%s/%s", path, fileName)));
            long currentOffset = 0;

            while ((currentOffset < fileSize) && ((bytesReceived = input.read(buffer)) > 0)) {
                bosFile.write(buffer, 0, bytesReceived);
                currentOffset += bytesReceived;
            }
            bosFile.flush();
            bosFile.close();

            return true;
        } catch (Exception ex) {
            ex.printStackTrace();
            if (bosFile != null) {
                try {
                    bosFile.close();
                } catch (Exception e) {
                }
            }
            return false;
        }
    }

}
