package lightcontainer.utils;

import java.io.*;

public class FileSender {
    private static final int DEFAULT_BUFFER = 8000;
    private final String path;

    public FileSender(String path) {
        this.path = path;
    }

    public boolean sendFile(String filename, OutputStream out, long fileSize, String aesKey, String iv) throws IOException {
        BufferedInputStream bisFile;
        try {
            File f = new File(String.format("%s/%s", path, filename));
            if (f.exists()) {
                bisFile = new BufferedInputStream(new FileInputStream(f));
                AES_GCM.decryptStream(bisFile, out, fileSize, aesKey, iv);
                return true;
            } else
                return false;
        } catch (IOException | AES_GCM.AesGcmException ex) {
            throw new IOException();
        }
    }

    public boolean sendFile(String filename, OutputStream out) throws IOException {
        BufferedInputStream bisFile;
        int bytesRead = 0;
        try {
            File file = new File(String.format("%s/%s", path, filename));
            long fileSize = file.length();
            if (file.exists()) {
                byte[] buffer = new byte[DEFAULT_BUFFER];
                bisFile = new BufferedInputStream(new FileInputStream(file));
                long currentOffset = 0;
                while ((currentOffset < fileSize) && (bytesRead = bisFile.read(buffer)) > 0) {
                    out.write(buffer, 0, bytesRead);
                    out.flush();
                    currentOffset += bytesRead;
                }
                bisFile.close();
                return true;
            } else
                return false;
        } catch (IOException ex) {// todo change
            throw ex;
        }
    }

}